

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.URL;
import java.net.URLClassLoader;
import java.net.URLDecoder;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map.Entry;
import java.util.Map;
import java.util.Properties;
import java.util.Set;

import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityTransaction;
import javax.persistence.Persistence;
import javax.persistence.Query;
import javax.transaction.TransactionManager;
import javax.transaction.UserTransaction;

import org.drools.KnowledgeBase;
import org.drools.KnowledgeBaseFactory;
import org.drools.SystemEventListenerFactory;
import org.drools.base.MapGlobalResolver;
import org.drools.builder.KnowledgeBuilder;
import org.drools.builder.KnowledgeBuilderFactory;
import org.drools.builder.ResourceType;
import org.drools.compiler.BPMN2ProcessFactory;
import org.drools.compiler.ProcessBuilderFactory;
import org.drools.io.ResourceFactory;
import org.drools.logger.KnowledgeRuntimeLogger;
import org.drools.logger.KnowledgeRuntimeLoggerFactory;
import org.drools.marshalling.impl.ProcessMarshallerFactory;
import org.drools.persistence.info.SessionInfo;
import org.drools.persistence.info.WorkItemInfo;
import org.drools.persistence.jpa.JPAKnowledgeService;
import org.drools.runtime.Environment;
import org.drools.runtime.EnvironmentName;
import org.drools.runtime.KnowledgeSessionConfiguration;
import org.drools.runtime.StatefulKnowledgeSession;
import org.drools.runtime.process.ProcessInstance;
import org.drools.runtime.process.ProcessRuntimeFactory;
import org.drools.runtime.process.WorkItem;
import org.drools.runtime.process.WorkItemManager;
import org.hibernate.HibernateException;
import org.jbpm.bpmn2.BPMN2ProcessProviderImpl;
import org.jbpm.bpmn2.xml.TaskHandler;
import org.jbpm.marshalling.impl.ProcessMarshallerFactoryServiceImpl;
import org.jbpm.process.audit.JPAProcessInstanceDbLog;
import org.jbpm.process.audit.JPAWorkingMemoryDbLogger;
import org.jbpm.process.builder.ProcessBuilderFactoryServiceImpl;
import org.jbpm.process.instance.ProcessRuntimeFactoryServiceImpl;
import org.jbpm.process.instance.impl.demo.DoNothingWorkItemHandler;
import org.jbpm.process.workitem.wsht.CommandBasedWSHumanTaskHandler;
import org.jbpm.task.AccessType;
import org.jbpm.task.Content;
import org.jbpm.task.Task;
import org.jbpm.task.TaskData;
import org.jbpm.task.query.TaskSummary;
import org.jbpm.task.service.ContentData;
import org.jbpm.task.service.TaskClient;
import org.jbpm.task.service.hornetq.CommandBasedHornetQWSHumanTaskHandler;
import org.jbpm.task.service.hornetq.HornetQTaskClientConnector;
import org.jbpm.task.service.hornetq.HornetQTaskClientHandler;
import org.jbpm.task.service.mina.MinaTaskClientConnector;
import org.jbpm.task.service.mina.MinaTaskClientHandler;
import org.jbpm.task.service.responsehandlers.BlockingGetContentResponseHandler;
import org.jbpm.task.service.responsehandlers.BlockingGetTaskResponseHandler;
import org.jbpm.task.service.responsehandlers.BlockingQueryGenericResponseHandler;
import org.jbpm.task.service.responsehandlers.BlockingTaskOperationResponseHandler;
import org.jbpm.task.service.responsehandlers.BlockingTaskSummaryResponseHandler;
import org.jbpm.workflow.instance.node.WorkItemNodeInstance;



public class JbpmUtil {

	private static String ipAddress = "127.0.0.1";
	private static int port = 9123;
	private static TaskClient client;
	private static StatefulKnowledgeSession ksession;
	public static boolean newsession = false;
	private static KnowledgeBase kbase;
	private static int thcount = 0;
	private static Environment env;
	private static KnowledgeSessionConfiguration config;
	private static CommandBasedWSHumanTaskHandler taskHandler1;
	private static CommandBasedWSHumanTaskHandler taskHandler2;
	public static Map<Integer, StatefulKnowledgeSession> ksmap = new HashMap<Integer, StatefulKnowledgeSession>();
//	/public static List<StatefulKnowledgeSession> kslist = new ArrayList<StatefulKnowledgeSession>();
	private static int limit = 50;
	private static List<Long> pendingtaskls=null;
	

	public static void init() throws Exception {
		kbase = readKnowledgeBase();
		Properties properties = new Properties();
		
		config = KnowledgeBaseFactory
				.newKnowledgeSessionConfiguration(properties);
	}

	public static KnowledgeBase readKnowledgeBase() throws Exception {
		ProcessBuilderFactory
				.setProcessBuilderFactoryService(new ProcessBuilderFactoryServiceImpl());
		ProcessMarshallerFactory
				.setProcessMarshallerFactoryService(new ProcessMarshallerFactoryServiceImpl());
		ProcessRuntimeFactory
				.setProcessRuntimeFactoryService(new ProcessRuntimeFactoryServiceImpl());
		BPMN2ProcessFactory
				.setBPMN2ProcessProvider(new BPMN2ProcessProviderImpl());
		KnowledgeBuilder kbuilder = KnowledgeBuilderFactory
				.newKnowledgeBuilder();
		kbuilder.add(ResourceFactory.newClassPathResource("demoflow.rf"),
				ResourceType.DRF);

		kbuilder.add(ResourceFactory.newClassPathResource("titanflow.rf"),
				ResourceType.DRF);

		kbuilder.add(ResourceFactory.newClassPathResource("loadallabrs.rf"),
				ResourceType.DRF);

		return kbuilder.newKnowledgeBase();
	}

	

	
	public static void registerHandler(StatefulKnowledgeSession ksession)
			throws Exception {
		CommandBasedHornetQWSHumanTaskHandler taskHandler = new CommandBasedHornetQWSHumanTaskHandler(
				ksession);
		ksession.getWorkItemManager().registerWorkItemHandler("Human Task",
				taskHandler);
		 TaskClient client = new TaskClient(new HornetQTaskClientConnector("pe client", new HornetQTaskClientHandler(SystemEventListenerFactory.getSystemEventListener())));
		 client.connect("127.0.0.1", 5446);
		 taskHandler.setClient(client);
		taskHandler.connect();
		System.out.println("New Task handler created--------------------");

	}

	public static StatefulKnowledgeSession instantSession() throws Exception {
		long st = System.currentTimeMillis();
		EntityManagerFactory emf = Persistence
		.createEntityManagerFactory("org.jbpm.persistance.jpa");

		Environment env = KnowledgeBaseFactory.newEnvironment();
		env.set(EnvironmentName.ENTITY_MANAGER_FACTORY, emf);
		env.set(EnvironmentName.TRANSACTION_MANAGER, getTransactionManager());
		env.set(EnvironmentName.GLOBALS, new MapGlobalResolver());
		StatefulKnowledgeSession ksession = JPAKnowledgeService
				.newStatefulKnowledgeSession(kbase, config, env);

		System.out.println("Time taken for Ksession--->"
				+ (System.currentTimeMillis() - st));
		registerHandler(ksession);

		return ksession;
	}

	

	public static TransactionManager getTransactionManager()
			throws HibernateException {
		try {
			return (TransactionManager) new InitialContext()
					.lookup("java:/TransactionManager");
		} catch (NamingException e) {
			throw new RuntimeException(e);
		}
	}

	public static void dispose() {
		try {
			ksession.dispose();

			ksession = null;
			System.out.println("session and taskhandler disposed...........");
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public static void getClient() throws Exception {
		if (client == null) {
			client = new TaskClient(new MinaTaskClientConnector(
					"org.drools.process.workitem.wsht.WSHumanTaskHandler",
					new MinaTaskClientHandler(SystemEventListenerFactory
							.getSystemEventListener())));
			client.connect(ipAddress, port);
			System.out
					.println(" #################### Client Connected ####################");
		}
	}

	public static HashMap<String, Object> getContentVariables(TaskData td) {
		HashMap<String, Object> map = new HashMap<String, Object>();
		try {
			Object obj = null;
			BlockingGetContentResponseHandler handlerC = new BlockingGetContentResponseHandler();
			client.getContent(td.getOutputContentId(), handlerC);
			Content content = handlerC.getContent();

			handlerC.waitTillDone(500);
			ByteArrayInputStream bais = new ByteArrayInputStream(
					content.getContent());
			ObjectInputStream ois = new ObjectInputStream(bais);
			obj = ois.readObject();
			System.out.println("Task Properties value#" + obj.toString());

			String str = obj.toString().replace("}", "").replace("{", "");
			String temp[] = null;
			temp = str.split(",");
			for (int i = 0; i < temp.length; i++) {
				String splitted[] = temp[i].split("=");
				if (!(splitted.length < 2)) {
					map.put(splitted[0].trim(),
							splitted[1].trim().replace(":", ","));
				}
			}

		} catch (Exception e) {
			e.printStackTrace();
		}
		return map;
	}

}
